Attribute VB_Name = "Module1"
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long


Declare Function SetWindowWord Lib "User32" (ByVal hwnd As Integer, _
      ByVal Index As Integer, ByVal wNewWord As Integer) As Integer
Global Const GWW_HWNDPARENT = -8
Global OriginalParenthWnd As Integer

Public nextFile As Long

Public Type World
  WorldName(1 To 200) As String
  WorldChar(1 To 200) As String
  WorldCond(1 To 200) As String
  WorldType(1 To 200) As String
  IntroReturn(1 To 200) As String
  WorldBkGr(1 To 200) As String
  WorldMidi(1 To 200) As String
  WorldSprite1(1 To 200) As String
  WorldSprite2(1 To 200) As String
  WorldSprite3(1 To 200) As String
  WorldSprite4(1 To 200) As String
  WorldHotSpots(1 To 200) As String
  WorldHotButton(1 To 200) As Boolean
  WorldHotScroll(1 To 200) As String
  WorldHotType(1 To 200) As String
  WorldHotItem(1 To 200) As String
  HotRenu(1 To 200) As String
  WorldChange(1 To 200) As String
  WorldText(1 To 200) As String
  FrameWalk(1 To 200) As Integer
  m_X(1 To 200) As String
  m_Y(1 To 200) As String
  m_SX(1 To 200) As String
  m_SY(1 To 200) As String
  m_FX(1 To 200) As String
  m_FY(1 To 200) As String
End Type

Public Type SpriteSettings
  HeroSettX(1 To 200) As String
  HeroSettY(1 To 200) As String
  HeroStrX(1 To 200) As String
  HeroStrY(1 To 200) As String
  HeroMoveX(1 To 200) As String
  HeroMoveY(1 To 200) As String
End Type

Public Type Walking
 TotalFrames As Integer
 DefLoc As String
 BMPname As String
 Soundz As String
 AddZero As Boolean
End Type

Public Type Standing
 TotalFrames As Integer
 BMPname As String
 Soundz As String
 AddZero As Boolean
End Type

Public Type CharacterStrength
 HP As String
 MP As String
 EXP As Long
 EXPg As Integer
 Level As Integer
 Gold As Long
 Goldt As Integer
 Hit1Snd As String
 Hit2Snd As String
 WinSnd As String
 DieSnd As String
End Type

Public Type NormalAttacks
 AttackName(1 To 99) As String
 TotalFrames(1 To 99) As Integer
 BMPname(1 To 99) As String
 PreBMP(1 To 99) As String
 EndBMP(1 To 99) As String
 PreTotFrame(1 To 99) As String
 EndTotFrame(1 To 99) As String
 Soundz(1 To 99) As String
 Sound2(1 To 99) As String
 Sound3(1 To 99) As String
 mUsed(1 To 99) As Integer
 mType(1 To 99) As String
 aX(1 To 99) As String
 aY(1 To 99) As String
 aSX(1 To 99) As String
 aSY(1 To 99) As String
 SFrame1(1 To 99) As Variant
 SFrame2(1 To 99) As Variant
 SFrame3(1 To 99) As Variant
 AddZero(1 To 99) As Boolean
 AttackDamage(1 To 99) As Integer
End Type

Public Type e_NormalAttacks
 CharNme As String
 HP As Variant
 MP As Variant
 AttStyle As String
 Smart As String
 Hit1Snd As String
 Hit2Snd As String
 WinSnd As String
 DieSnd As String
 AttackName(1 To 99) As String
 TotalFrames(1 To 99) As Integer
 BMPname(1 To 99) As String
 PreBMP(1 To 99) As String
 EndBMP(1 To 99) As String
 PreTotFrame(1 To 99) As String
 EndTotFrame(1 To 99) As String
 Soundz(1 To 99) As String
 Sound2(1 To 99) As String
 Sound3(1 To 99) As String
 mType(1 To 99) As String
 mUsed(1 To 99) As Integer
 aX(1 To 99) As String
 aY(1 To 99) As String
 aSX(1 To 99) As String
 aSY(1 To 99) As String
 SFrame1(1 To 99) As Variant
 SFrame2(1 To 99) As Variant
 SFrame3(1 To 99) As Variant
 AddZero(1 To 99) As Boolean
 AttackDamage(1 To 99) As Integer
End Type

Public Type e_Settings
 e_FilNme(1 To 200) As String
 e_BmpNme(1 To 200) As String
 e_DefLoc(1 To 200) As String
 e_Frames(1 To 200) As String
 e_AddZero(1 To 200) As String
 e_X(1 To 200) As String
 e_Y(1 To 200) As String
 e_SX(1 To 200) As String
 e_SY(1 To 200) As String
End Type

Type GameOptions
 SaveLoad As Integer
 EquipItem As Integer
 EquipWeapon As Integer
 EquipArmour As Integer
 MultiPlayerFight As Integer
 Money As Integer
 ExpPoints As Integer
 MSPic As String
 SupScene As String
 Parts As Integer
End Type

Type WeaponLoaded
wName As String
damageAdd As Integer
itemDoes As String
itemDoesVal As Variant
bmpNme As String
CallCond As String
End Type

Type ArmourLoaded
wName As String
defAdd As Integer
BreakP As String
itemDoes As String
itemDoesVal As Variant
bmpNme As String
CallCond As String
End Type


Type ItemHas
Weapons(1 To 100) As String
WeapOwned(1 To 100) As Integer
WeapHas As Integer
Armour(1 To 100) As String
ArmOwned(1 To 100) As Integer
ArmHas As Integer
Items(1 To 100) As String
ItmOwned(1 To 100) As Integer
ItmHas As Integer
End Type

Public HotRenu(1 To 20) As Integer
Public myTurn As Boolean
Public goodGuy As Boolean
Public internetFight As Boolean
Public host As Boolean
Public doRScrl As Boolean
Public oldR As Integer
Public doScroll As Boolean
Public oldI As Integer
Public IH As ItemHas
Public tmpX As Integer
Public ResumePlay As Boolean
Public e_Done As Integer
Public WaitUserContinue As Boolean
Public WaitUserResponse As Boolean
Public eTotHP As Integer
Public CharTotHP As Integer
Public CharTotMP As Integer
Public Weap As WeaponLoaded
Public Arm As ArmourLoaded
Public ConfirmContinue As Boolean
Public globNum As Integer
Public FightLoaded As Boolean
Public GlobalPause As Boolean
Public lstmsg As String
Public rPath As String
Public GameOpn As GameOptions
Public GlobLoaded As String
Public selNum As Variant
Public selType As Variant
Public MagI As Variant
Public Snd1(1 To 4) As Integer
Public snd2(1 To 4) As Integer
Public Snd3(1 To 4) As Integer
Public AcSnd(1 To 3)
Public ModeIs As String
Public FrameWalk As Integer
Public TmpSprNme(1 To 4) As String
Public TmpSprNme2(1 To 4) As String
Public TmpSprF(1 To 4)
Public TmpSprX(1 To 4)
Public TmpSprY(1 To 4)
Public TmpSprSX(1 To 4)
Public TmpSprSY(1 To 4)
Public oldSprNme(1 To 4) As String
Public oldSprX(1 To 4)
Public oldSprY(1 To 4)
Public oldSprSX(1 To 4)
Public oldSprSY(1 To 4)
Public GlobalR As Integer
Public HerosName As String
Public wld As World
Public SpriteSett As SpriteSettings
Public NormDone As Integer
Public Walk1 As Walking
Public Stand1 As Standing
Public CharStr As CharacterStrength
Public CharType As String
Public EnStyle As String
Public EnSmarts As String
Public NormAttack As NormalAttacks
Public e_NormAttack As e_NormalAttacks
Public e_Sett As e_Settings
Public DoAttack As Boolean

Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_MEMORY = &H4
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10


Public Function GetIni(Path, Proces, AppNme)
Dim Process As String
Process = Proces
buffer$ = String$(250, " ")
num& = 250
result = GetPrivateProfileString(AppNme, Process, vbNullString, buffer$, num&, Path)
buffer$ = Mid$(buffer$, 1, result)
GetIni = buffer$
End Function

Public Function WriteIni(Path, Process As String, Key, AppNme)
Dim Keyy As String
Keyy = Key
result = WritePrivateProfileString(AppNme, Process, Keyy, Path)
WriteIni = result
End Function

Public Sub PlayMidi(snd, flag)
r = Right(snd, 3)
If UCase(r) = "MID" Then
 If flag = "open" Then
  X& = mciSendString("open " & snd & " Type sequencer Alias MFile", 0&, 0, 0)
  X& = mciSendString("play MFile", 0&, 0, 0)
 Else
  X& = mciSendString("stop MFile", 0&, 0, 0)
  X& = mciSendString("close MFile", 0&, 0, 0)
 End If
Else
If UCase(flag) <> "CLOSE" Then r = PlaySound(snd, 0, 0&)
End If
End Sub

Public Function RC4(SS, S)
On Error Resume Next
Text2 = SS
Text1 = S
For i = 0 To 255
    DDD = DDD & Chr(i Mod 256 + 1)
Next
SBox = DDD
DDD = ""
For i = 0 To 255
    k = Asc(Mid(Text2, i Mod Len(Key), 1))
    j = (j + Asc(Mid(SBox, i, 1)) + k) Mod 256
    DDD = DDD & Chr(j Mod 256 + 1)
Next
SBox = DDD
DDD = ""
On Error Resume Next
texti = Text1
For i = 1 To Len(Text1)
    C = Asc(Mid(texti, i, 1)) - 1
    j = (j + Asc(Mid(SBox, i, 1))) Mod 256
    T = (Asc(Mid(SBox, i, 1)) + Asc(Mid(SBox, j, 1))) Mod 256
    k = Asc(Mid(SBox, T, 1)) Mod 256
    C = C Xor k
    Mid(texti, i, 1) = Chr(C Mod 256 + 1)
Next
RC4 = texti
End Function


Public Sub LOADgame(pPath)
r2 = RC4(RC4("sodtbm5429ddghe55e", "20932ufks23rtghku5u64"), GetIni(pPath, "Key", "Game Config"))
r = FileDateTime(pPath)
For i = 1 To Len(r)
  If Mid(r, i, 1) = " " Then
      datecheck = Mid(r, 1, i - 1)
      GoTo skipi
    End If
Next i
skipi:
For n = 1 To Len(pPath)
  r = Right(pPath, n)
  If Left(r, 1) = "\" Then
       gameNme = Mid(pPath, Len(pPath) - n + 2)
       gameNme = Mid(gameNme, 1, Len(gameNme) - 4)
       GoTo donenme
End If
Next n
donenme:

DateIs = RC4(r2, GetIni(pPath, "Verif", "Game Config"))
If datecheck <> DateIs Then
MsgBox "Datecheck overriden! MHU WHU HAHAHA! DEBUG:" & DateIs
'  MsgBox "THIS FILE HAS BEEN EDITED AND IS CORRUPTED!   Sorry!"

 ' Exit Sub
End If
GameOpn.SaveLoad = GetIni(pPath, "SL", "Game Config")
GameOpn.EquipItem = GetIni(pPath, "I", "Game Config")
GameOpn.EquipWeapon = GetIni(pPath, "W", "Game Config")
GameOpn.EquipArmour = GetIni(pPath, "A", "Game Config")
GameOpn.MultiPlayerFight = GetIni(pPath, "I2", "Game Config")
GameOpn.Money = GetIni(pPath, "M", "Game Config")
GameOpn.ExpPoints = GetIni(pPath, "EXP", "Game Config")
GameOpn.MSPic = RC4(r2, GetIni(pPath, "SP", "Game Config"))
GameOpn.SupScene = RC4(r2, GetIni(pPath, "SS", "Game Config"))
GameOpn.Parts = RC4(r2, GetIni(pPath, "FR", "Game Config"))
Form1.List1.Clear
Form1.List1.AddItem gameNme
Form1.Label1.Caption = "Status: Game Loaded Successfully!"
End Sub

Public Sub LoadCharSett(p)
On Error Resume Next
HerosName = GetIni(p, "Name", "Character Settings File")
GlobLoaded = HerosName
CharStr.HP = GetIni(p, "HP", "Character Settings File")
CharTotHP = CharStr.HP
CharStr.MP = GetIni(p, "MP", "Character Settings File")
CharTotMP = CharStr.MP

CharStr.Hit1Snd = GetIni(p, "Hit1Sd", "Character Settings File")
CharStr.Hit2Snd = GetIni(p, "Hit2Sd", "Character Settings File")
CharStr.WinSnd = GetIni(p, "WinSnd", "Character Settings File")
CharStr.DieSnd = GetIni(p, "DieSnd", "Character Settings File")

Walk1.TotalFrames = GetIni(p, "Frames", "Walking Animation")
Walk1.BMPname = GetIni(p, "BMPname", "Walking Animation")
Walk1.Soundz = GetIni(p, "Sound", "Walking Animation")

Stand1.TotalFrames = GetIni(p, "Frames", "Standing Animation")
Stand1.BMPname = GetIni(p, "BMPname", "Standing Animation")
Stand1.AddZero = GetIni(p, "AddZero", "Standing Animation")
Stand1.Soundz = GetIni(p, "Sound", "Standing Animation")

For i = 1 To 99
r = GetIni(p, "Name", "Normal Attack #" & i)
If r = "" Then
MaxI = i - 1
GoTo skipit
Else
MaxI = MaxI + 1
End If
Next i
skipit:
NormDone = MaxI
For i = 1 To MaxI
 NormAttack.TotalFrames(i) = GetIni(p, "Frames", "Normal Attack #" & i)
 NormAttack.AttackName(i) = GetIni(p, "Name", "Normal Attack #" & i)
 NormAttack.BMPname(i) = GetIni(p, "BMPname", "Normal Attack #" & i)
 NormAttack.PreBMP(i) = GetIni(p, "PreBMP", "Normal Attack #" & i)
 NormAttack.PreTotFrame(i) = GetIni(p, "PreF", "Normal Attack #" & i)
 NormAttack.EndBMP(i) = GetIni(p, "EndBMP", "Normal Attack #" & i)
 NormAttack.EndTotFrame(i) = GetIni(p, "EndF", "Normal Attack #" & i)
 NormAttack.AttackDamage(i) = GetIni(p, "Damage", "Normal Attack #" & i)
 NormAttack.Soundz(i) = GetIni(p, "Sound", "Normal Attack #" & i)
 NormAttack.Sound2(i) = GetIni(p, "Sound2", "Normal Attack #" & i)
 NormAttack.Sound3(i) = GetIni(p, "Sound3", "Normal Attack #" & i)
 NormAttack.mUsed(i) = GetIni(p, "mUsed", "Normal Attack #" & i)
 NormAttack.mType(i) = GetIni(p, "mType", "Normal Attack #" & i)
 NormAttack.SFrame1(i) = GetIni(p, "SFrame1", "Normal Attack #" & i)
 NormAttack.SFrame2(i) = GetIni(p, "SFrame2", "Normal Attack #" & i)
 NormAttack.SFrame3(i) = GetIni(p, "SFrame3", "Normal Attack #" & i)
 NormAttack.aX(i) = GetIni(p, "Ax", "Normal Attack #" & i)
 NormAttack.aY(i) = GetIni(p, "Ay", "Normal Attack #" & i)
 NormAttack.aSX(i) = GetIni(p, "AsX", "Normal Attack #" & i)
 NormAttack.aSY(i) = GetIni(p, "AsY", "Normal Attack #" & i)
 NormAttack.AddZero(i) = GetIni(p, "AddZero", "Normal Attack #" & i)
Next i
End Sub


Public Sub LoadWorldSet(pPath)
On Error GoTo handler
r2 = RC4(RC4("sodtbm5429ddghe55e", "20932ufks23rtghku5u64"), GetIni(pPath, "Key", "GameFile"))
GlobalR = 0
r6 = RC4(r2, GetIni(pPath, "Verif", "GameFile"))
rcheck = FileDateTime(pPath)
For i = 1 To Len(rcheck)
  If Mid(rcheck, i, 1) = " " Then
      datecheck = Mid(rcheck, 1, i - 1)
      GoTo skipi
    End If
Next i
skipi:
If datecheck <> r6 Then
MsgBox "Date check overridden!!!  DEBUG:" & r6

' MsgBox "THIS FILE HAS BEEN EDTIED!!! POSSIBLE CORRUPTION!  SORRY, CANT LOAD!"
'Exit Sub
End If
For doWorld = 1 To 200
wld.WorldName(doWorld) = GetIni(pPath, "WorldName", "World #:" & doWorld)
If wld.WorldName(doWorld) = "" Then Exit Sub
GlobalR = GlobalR + 1
DoEvents
wld.WorldChar(doWorld) = GetIni(pPath, "WorldChar", "World #:" & doWorld)
wld.WorldCond(doWorld) = GetIni(pPath, "WorldCond", "World #:" & doWorld)
wld.IntroReturn(doWorld) = GetIni(pPath, "IntroReturn", "World #:" & doWorld)
wld.WorldType(doWorld) = GetIni(pPath, "WorldType", "World #:" & doWorld)
wld.WorldBkGr(doWorld) = GetIni(pPath, "WorldBkGr", "World #:" & doWorld)
wld.WorldMidi(doWorld) = GetIni(pPath, "WorldMidi", "World #:" & doWorld)
wld.WorldSprite1(doWorld) = GetIni(pPath, "WorldSprite1", "World #:" & doWorld)
wld.WorldSprite2(doWorld) = GetIni(pPath, "WorldSprite2", "World #:" & doWorld)
wld.WorldSprite3(doWorld) = GetIni(pPath, "WorldSprite3", "World #:" & doWorld)
wld.WorldSprite4(doWorld) = GetIni(pPath, "WorldSprite4", "World #:" & doWorld)
wld.WorldHotSpots(doWorld) = GetIni(pPath, "WorldHotSpots", "World #:" & doWorld)
wld.WorldHotButton(doWorld) = GetIni(pPath, "WorldHotButton", "World #:" & doWorld)
wld.WorldHotScroll(doWorld) = GetIni(pPath, "WorldHotScroll", "World #:" & doWorld)
wld.WorldHotType(doWorld) = GetIni(pPath, "WorldHotType", "World #:" & doWorld)
wld.WorldHotItem(doWorld) = GetIni(pPath, "WorldHotItem", "World #:" & doWorld)
wld.WorldChange(doWorld) = GetIni(pPath, "WorldChange", "World #:" & doWorld)
wld.WorldText(doWorld) = GetIni(pPath, "WorldText", "World #:" & doWorld)
wld.FrameWalk(doWorld) = GetIni(pPath, "FrameWalk", "World #:" & doWorld)
FrameWalk = wld.FrameWalk(doWorld)
wld.m_X(doWorld) = GetIni(pPath, "m_X", "World #:" & doWorld)
wld.m_Y(doWorld) = GetIni(pPath, "m_Y", "World #:" & doWorld)
wld.m_SX(doWorld) = GetIni(pPath, "m_SX", "World #:" & doWorld)
wld.m_SY(doWorld) = GetIni(pPath, "m_SY", "World #:" & doWorld)
wld.m_FX(doWorld) = GetIni(pPath, "m_FX", "World #:" & doWorld)
wld.m_FY(doWorld) = GetIni(pPath, "m_FY", "World #:" & doWorld)
SpriteSett.HeroSettX(doWorld) = GetIni(pPath, "HeroSettX", "World #:" & doWorld)
SpriteSett.HeroSettY(doWorld) = GetIni(pPath, "HeroSettY", "World #:" & doWorld)
SpriteSett.HeroStrX(doWorld) = GetIni(pPath, "HeroStrX", "World #:" & doWorld)
SpriteSett.HeroStrY(doWorld) = GetIni(pPath, "HeroStrY", "World #:" & doWorld)
SpriteSett.HeroMoveX(doWorld) = GetIni(pPath, "HeroMoveX", "World #:" & doWorld)
SpriteSett.HeroMoveY(doWorld) = GetIni(pPath, "HeroMoveY", "World #:" & doWorld)
e_Sett.e_FilNme(doWorld) = GetIni(pPath, "e_FilNme", "World #:" & doWorld)
e_Sett.e_BmpNme(doWorld) = GetIni(pPath, "e_BmpNme", "World #:" & doWorld)
e_Sett.e_DefLoc(doWorld) = GetIni(pPath, "e_DefLoc", "World #:" & doWorld)
e_Sett.e_Frames(doWorld) = GetIni(pPath, "e_Frames", "World #:" & doWorld)
e_Sett.e_AddZero(doWorld) = GetIni(pPath, "e_AddZero", "World #:" & doWorld)
e_Sett.e_X(doWorld) = GetIni(pPath, "e_X", "World #:" & doWorld)
e_Sett.e_Y(doWorld) = GetIni(pPath, "e_Y", "World #:" & doWorld)
e_Sett.e_SX(doWorld) = GetIni(pPath, "e_SX", "World #:" & doWorld)
e_Sett.e_SY(doWorld) = GetIni(pPath, "e_SY", "World #:" & doWorld)
wld.HotRenu(doWorld) = "00000000000000000000"
DoEvents
Next doWorld
GoTo done
handler:
MsgBox "ERROR: File " & pPath & " wasn't found!!!!!"
done:
End Sub

Public Function FindSetGlobNum(SearchWorld)
For i = 1 To 200
If UCase(SearchWorld) = UCase(wld.WorldName(i)) Then
     FindSetGlobNum = i
     Exit Function
End If
Next i
End Function

Sub LoadSpriteSett()
For clearit = 1 To 4
TmpSprNme(clearit) = ""
TmpSprF(clearit) = ""
TmpSprX(clearit) = ""
TmpSprY(clearit) = ""
TmpSprSX(clearit) = ""
TmpSprSY(clearit) = ""
oldSprNme(clearit) = ""
oldSprX(clearit) = ""
oldSprY(clearit) = ""
oldSprSX(clearit) = ""
oldSprSY(clearit) = ""
Next clearit

For l = 1 To 4
lastdid = 0
If l = 1 Then info = wld.WorldSprite1(GlobalR)
If l = 2 Then info = wld.WorldSprite2(GlobalR)
If l = 3 Then info = wld.WorldSprite3(GlobalR)
If l = 4 Then info = wld.WorldSprite4(GlobalR)
lastdid = 1
For i = 1 To Len(info)
 r = Mid(info, i, 1)
 If r = "." Then
 TmpSprNme(l) = Mid(info, 1, i - 1)
 oldSprNme(l) = TmpSprNme(l)
 TmpSprNme2(l) = "0" & TmpSprNme(l)
 lastdid = i + 1
 GoTo nextone
 End If
Next i
nextone:
doneit = 0
i = i + 1

For n = i To Len(info)
r = Mid(info, n, 1)
If r = "^" Then
TmpSprF(l) = Mid(info, lastdid, n - i)
lastdid = n + 1
GoTo nexttwo
End If
Next n

nexttwo:
For T = n To Len(info)
r = Mid(info, T, 1)
If r = "." Then
TmpSprX(l) = Mid(info, lastdid, T - n - 1)
oldSprX(l) = TmpSprX(l)
lastdid = lastdid + (T - n)
T = T + 1
GoTo nextthree
End If
Next T

nextthree:
n = 0
For n = T To Len(info)
DoIt = DoIt + 1
r = Mid(info, n, 1)
If r = "." Then
TmpSprY(l) = Mid(info, lastdid, n - T)
oldSprY(l) = TmpSprY(l)
GoTo nextFour
End If
Next n
nextFour:
n = n + 1

For Y = n To Len(info)
didita = didita + 1
r = Mid(info, Y, 1)
If r = "." Then
TmpSprSX(l) = Mid(info, n, Y - n)
oldSprSX(l) = TmpSprSX(l)
TmpSprSY(l) = Mid(info, Y + 1, Len(info))
oldSprSY(l) = TmpSprSY(l)
GoTo done
End If
Next Y
done:
Next l
End Sub


Function GetCheckI(NeedI, str)
If UCase(str) <> "S" Then
For i = 1 To Len(wld.WorldHotType(GlobalR))
  r = Mid(wld.WorldHotType(GlobalR), i, 1)
  If UCase(r) <> "S" Then myI = myI + 1
  If UCase(r) = UCase(str) Then
  If NeedI = myI Then GoTo done
  End If
Next i
done:
GetCheckI = myI
Else
For i = 1 To Len(wld.WorldHotType(GlobalR))
  r = Mid(wld.WorldHotType(GlobalR), i, 1)
  If UCase(r) = UCase(str) Then
  myI = myI + 1
  If NeedI = myI Then GoTo done2
  End If
Next i
done2:
GetCheckI = myI
End If
End Function

Sub LoadEnemySett(Optional p)
On Error Resume Next
If IsMissing(p) = True Then
p = rPath & e_Sett.e_FilNme(GlobalR)
End If
e_NormAttack.CharNme = GetIni(p, "Name", "Character Settings File")
e_NormAttack.HP = GetIni(p, "HP", "Character Settings File")
eTotHP = e_NormAttack.HP
e_NormAttack.MP = GetIni(p, "MP", "Character Settings File")
e_NormAttack.AttStyle = GetIni(p, "EnStyle", "Character Settings File")
e_NormAttack.Smart = GetIni(p, "EnSmarts", "Character Settings File")

e_NormAttack.Hit1Snd = GetIni(p, "Hit1Sd", "Character Settings File")
e_NormAttack.Hit2Snd = GetIni(p, "Hit2Sd", "Character Settings File")
e_NormAttack.WinSnd = GetIni(p, "WinSnd", "Character Settings File")
e_NormAttack.DieSnd = GetIni(p, "DieSnd", "Character Settings File")

e_Sett.e_BmpNme(GlobalR) = GetIni(p, "BMPname", "Standing Animation")
e_Sett.e_DefLoc(GlobalR) = GetIni(p, "DefLoc", "Standing Animation")
e_Sett.e_AddZero(GlobalR) = GetIni(p, "AddZero", "Standing Animation")
e_Sett.e_Frames(GlobalR) = GetIni(p, "Frames", "Standing Animation")


For i = 1 To 99
r = GetIni(p, "Name", "Normal Attack #" & i)
If r = "" Then
MaxI = i - 1
GoTo skipit
Else
MaxI = MaxI + 1
End If
Next i
skipit:
e_Done = MaxI
For i = 1 To MaxI
 e_NormAttack.TotalFrames(i) = GetIni(p, "Frames", "Normal Attack #" & i)
 e_NormAttack.AttackName(i) = GetIni(p, "Name", "Normal Attack #" & i)
 e_NormAttack.BMPname(i) = GetIni(p, "BMPname", "Normal Attack #" & i)
 e_NormAttack.PreBMP(i) = GetIni(p, "PreBMP", "Normal Attack #" & i)
 e_NormAttack.PreTotFrame(i) = GetIni(p, "PreF", "Normal Attack #" & i)
 e_NormAttack.EndBMP(i) = GetIni(p, "EndBMP", "Normal Attack #" & i)
 e_NormAttack.EndTotFrame(i) = GetIni(p, "EndF", "Normal Attack #" & i)
 e_NormAttack.AttackDamage(i) = GetIni(p, "Damage", "Normal Attack #" & i)
 e_NormAttack.Soundz(i) = GetIni(p, "Sound", "Normal Attack #" & i)
 e_NormAttack.Sound2(i) = GetIni(p, "Sound2", "Normal Attack #" & i)
 e_NormAttack.Sound3(i) = GetIni(p, "Sound3", "Normal Attack #" & i)
 e_NormAttack.mType(i) = GetIni(p, "mType", "Normal Attack #" & i)
 e_NormAttack.mUsed(i) = GetIni(p, "mUsed", "Normal Attack #" & i)
 e_NormAttack.SFrame1(i) = GetIni(p, "SFrame1", "Normal Attack #" & i)
 e_NormAttack.SFrame2(i) = GetIni(p, "SFrame2", "Normal Attack #" & i)
 e_NormAttack.SFrame3(i) = GetIni(p, "SFrame3", "Normal Attack #" & i)
 e_NormAttack.aX(i) = GetIni(p, "Ax", "Normal Attack #" & i)
 e_NormAttack.aY(i) = GetIni(p, "Ay", "Normal Attack #" & i)
 e_NormAttack.aSX(i) = GetIni(p, "AsX", "Normal Attack #" & i)
 e_NormAttack.aSY(i) = GetIni(p, "AsY", "Normal Attack #" & i)
 e_NormAttack.AddZero(i) = GetIni(p, "AddZero", "Normal Attack #" & i)
Next i
End Sub


Sub CalculateDamage()
Dim snd As New EZSound
TotDmg = NormAttack.AttackDamage(globNum) + CharStr.Level - 1
TotDmg = TotDmg + Weap.damageAdd
e_NormAttack.HP = e_NormAttack.HP - TotDmg
If e_NormAttack.HP < 0 Then
ExpP = CharStr.Level + 10 + eTotHP - CharTotHP
If ExpP <= 0 Then ExpP = 10
OldGold = CharStr.Gold
CharStr.Goldt = Int((40 - 1 + 1) * Rnd + 1) + eTotHP - CharTotHP
If CharStr.Goldt <= 10 Then CharStr.Goldt = 10
CharStr.EXPg = ExpP
CharStr.EXP = CharStr.EXP + CharStr.EXPg
CharStr.Gold = CharStr.Gold + CharStr.Goldt
snd.Source = rPath & "Sounds\" & e_NormAttack.DieSnd
snd.Play
Form4.DoMsg ("ENEMY DEFEATED!!!")
GlobalPause = True
WaitUserResponse = True
Else
If TotDmg < 20 Then
snd.Source = rPath & "Sounds\" & e_NormAttack.Hit1Snd
Else
snd.Source = rPath & "Sounds\" & e_NormAttack.Hit2Snd
End If
snd.Play
Form4.DoMsg ("Enemy HIT! Enemy HP:" & e_NormAttack.HP)
    If internetFight = False Then
        Call CalculateEnemyAttack
    Else
        myTurn = True
        Form5.Command1.Enabled = True
    End If
End If
End Sub

Sub CalculateDamageE()
On Error Resume Next
Dim snd As New EZSound
TotDmg = e_NormAttack.AttackDamage(globNum) + 1 - Arm.defAdd
CharStr.HP = CharStr.HP - TotDmg
If Arm.BreakP = "" Then GoTo skips
If Mid(Arm.BreakP, 1, 1) <> "*" Then Arm.BreakP = Arm.BreakP - TotDmg
If Arm.BreakP <= 0 Then
tmpMsg = "      Armour has worn out!!!"
Arm.bmpNme = ""
Arm.CallCond = ""
Arm.defAdd = ""
Arm.itemDoes = ""
Arm.itemDoesVal = ""
Arm.wName = ""
End If
skips:
If CharStr.HP <= 0 Then
snd.Source = rPath & "Sounds\" & CharStr.DieSnd
snd.Play
Form4.DoMsg ("YOU HAVE BEEN DEFEATED!")
GlobalPause = True
WaitUserResponse = False
Form3.Visible = False
Form5.Visible = False
Form6.Visible = True
Form6.Command6.Enabled = True
'do died code here
Else
If TotDmg < 20 Then
snd.Source = rPath & "Sounds\" & CharStr.Hit1Snd
Else
snd.Source = rPath & "Sounds\" & CharStr.Hit2Snd
End If
snd.Play
Form4.DoMsg (HerosName & " HIT! HP:" & CharStr.HP & tmpMsg)
Form5.Label5.Caption = CharStr.HP
GlobalPause = False
Call Form3.DrawStandMode
End If
End Sub

Sub CalculateEnemyAttack()
If e_NormAttack.AttStyle = "Aggressive" Then
globNum = Int(e_Done * Rnd + 1)
DoAttack = True
Call Form3.BadAttack

ElseIf e_NormAttack.AttStyle = "Conservative" Then
globNum = Int(e_Done * Rnd) + 1
DoAttack = True
Call Form3.BadAttack

ElseIf e_NormAttack.AttStyle = "Defensive" Then
globNum = Int(e_Done * Rnd) + 1
DoAttack = True
Call Form3.BadAttack
End If
End Sub

Sub LoadItem(typeIs As String, itemIs As String)
'Dim tmp5 As Integer
rPath2 = App.Path
'rPath2 = "C:\my stuff\Seekers\Items\"
itemIs = Trim(itemIs)
If Right(rPath2, 1) <> "\" Then rPath2 = rPath2 & "\"
r2 = RC4(RC4("sodtbm5429ddghe55e", "20932ufks23rtghku5u64"), GetIni(rPath2 & itemIs & ".iEd", "Key", "Item Config"))
tmp0 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "NME", "Item Config"))
tmp1 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "DA", "Item Config"))
tmp2 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "DAA", "Item Config"))
tmp3 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "AB", "Item Config"))
tmp4 = GetIni(rPath2 & itemIs & ".iEd", "L5", "Item Config")
tmp5 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "V", "Item Config"))
tmp6 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "BN", "Item Config"))
tmp7 = RC4(r2, GetIni(rPath2 & itemIs & ".iEd", "CC", "Item Config"))

If typeIs = "W" Then
Weap.wName = tmp0
Weap.damageAdd = tmp1
Weap.itemDoes = tmp4
Weap.itemDoesVal = tmp5
Weap.bmpNme = tmp6
Weap.CallCond = tmp7
Form7.Visible = False
ElseIf typeIs = "A" Then
Arm.wName = tmp0
Arm.defAdd = tmp2
Arm.BreakP = tmp3
Arm.itemDoes = tmp4
Arm.itemDoesVal = tmp5
Arm.bmpNme = tmp6
Arm.CallCond = tmp7
Form7.Visible = False
Else
'other items
r = FindItem(itemIs, "I")
If IH.ItmOwned(r) = 0 Then GoTo skipitm


If tmp4 = "HP up/down" Then
CharStr.HP = CharStr.HP + tmp5
If CharStr.HP > CharTotHP Then CharStr.HP = CharTotHP
    If CharStr.HP <= 0 Then
        'do killed/poisoned to death code
    End If
Form4.Show
Form4.DoMsg (itemIs & " !" & Chr(13) & "New Character HP: " & CharStr.HP)
End If
If tmp4 = "MP up/down" Then
CharStr.MP = CharStr.MP + tmp5
If CharStr.MP > CharTotMP Then CharStr.MP = CharTotMP
If CharStr.MP < 0 Then CharStr.MP = 0
Form4.Show
Form4.DoMsg (itemIs & " !" & Chr(13) & "New Character MP: " & CharStr.MP)
End If
If tmp4 = "Gold up/down" Then
CharStr.Gold = CharStr.Gold + tmp5
Form4.Show
Form4.DoMsg ("Gold Found!!! (" & tmp5 & ")" & Chr(13) & "Total Gold Pieces: " & CharStr.Gold)
End If
If tmp4 = "Experience up/down" Then
CharStr.EXP = CharStr.EXP + tmp5
Form4.Show
Form4.DoMsg (itemIs & " !" & Chr(13) & "New Character Experience: " & CharStr.EXP)
End If
If tmp4 = "nothing" Then
Form4.Show
Form4.DoMsg ("I don't think I can use this here")
End If
If tmp4 = "Strength up/down" Then

End If
If tmp4 = "Defence up/down" Then

End If
If tmp4 = "MAX HP up" Then
CharTotHP = CharTotHP + tmp5
CharStr.HP = CharTotHP
Form4.Show
Form4.DoMsg ("MAXIMUM HP LEVEL INCREASED!!!" & Chr(13) & "Max HP Level: " & CharStr.HP)
End If
If tmp4 = "MAX MP up" Then
CharTotMP = CharTotMP + tmp5
CharStr.MP = CharTotMP
Form4.Show
Form4.DoMsg ("MAXIMUM MP LEVEL INCREASED!!!" & Chr(13) & "Max MP Level: " & CharStr.MP)
End If
'end other items
r = FindItem(itemIs, "I")
IH.ItmOwned(r) = IH.ItmOwned(r) - 1
If IH.ItmOwned(r) <= 0 Then

Form7.Visible = False
End If
skipitm:

End If

End Sub

Sub SetItem(pPath)

rPath2 = App.Path
'rPath2 = "c:\my stuff\Seekers\Items\"
If Right(rPath2, 1) <> "\" Then rPath2 = rPath2 & "\"
rPath2 = rPath2 & pPath
r2 = RC4(RC4("sodtbm5429ddghe55e", "20932ufks23rtghku5u64"), GetIni(rPath2 & itemIs & ".iEd", "Key", "Item Config"))
tmp0 = RC4(r2, GetIni(rPath2, "NME", "Item Config"))
tmp1 = RC4(r2, GetIni(rPath2, "T", "Item Config"))
If tmp1 = "W" Then
tmp1 = " - Weapon"
For i = 1 To IH.WeapHas
If IH.Weapons(i) = tmp0 Then itmCnt = IH.WeapOwned(i)
Next i
End If
If tmp1 = "A" Then
tmp1 = " - Armour"
For i = 1 To IH.ArmHas
If IH.Armour(i) = tmp0 Then itmCnt = IH.ArmOwned(i)
Next i
End If
If tmp1 = "I" Then
tmp1 = " - Item  "
For i = 1 To IH.ItmHas
If IH.Items(i) = tmp0 Then itmCnt = IH.ItmOwned(i)
Next i
End If
If itmCnt = 0 Then Exit Sub
Form7.List1.AddItem (tmp0 & "(" & itmCnt & ")" & tmp1)
End Sub

Function GetNextInformation(wldLook, EVENTlook, ThisI, Optional WldMid)
    lstNIs = 1
redoNIs:
      For ni = lstNIs To Len(wldLook)
       o = Mid(wldLook, ni, 2)
       If o = "`~" Then
          For et = ni + 2 To Len(wldLook)
               p = Mid(wldLook, et, 1)
               If p = "." Then
                 DoMe = DoMe + 1
                 checkI = GetCheckI(ThisI, EVENTlook)
                 If DoMe = checkI Then
                 wldNme = Mid(wldLook, et + 1, Mid(wldLook, ni + 2, et - (ni + 2)))
                 DoMe = 0
                 GoTo meisDone
                 Else
                 txt = Mid(wldLook, et + 1, Mid(wldLook, ni + 2, et - (ni + 2)))
                 lstNIs = lstNIs + Len(txt) + Len(Mid(wldLook, ni + 2, et - (ni + 2))) + 2
                 GoTo redoNIs
                 End If
                 End If
          Next et
      End If
      Next ni
meisDone:
If EVENTlook = "S" Then
FightLoaded = False
oldR = GlobalR
    r = FindSetGlobNum(wldNme)
    GlobalR = r
If UCase(WldMid) <> UCase(wld.WorldMidi(GlobalR)) Then Call PlayMidi(rPath & "Sounds\" & WldMid, "close")
DoEvents
If internetFight = True Then Exit Function
      If Mid(wld.WorldHotScroll(oldR), oldI, 1) <> "0" Then doScroll = True
      If Mid(wld.WorldHotScroll(oldR), oldI, 1) = "R" Then
      doRScrl = True
      Else
      doRScrl = False
      End If
      If UCase(wld.WorldType(GlobalR)) = "I" Then Call Form3.WaitIntro
      If UCase(wld.WorldType(GlobalR)) = "P" Then Call Form3.WaitMain
      If FightLoaded = False Then If UCase(wld.WorldType(GlobalR)) = "F" Then Call Form3.WaitFight
Else
GetNextInformation = wldNme
End If
End Function

Function FindItem(itm, typ)

If typ = "W" Then
For i = 1 To IH.WeapHas
If UCase(itm) = UCase(IH.Weapons(i)) Then
FindItem = i
Exit Function
End If
Next i
End If

If typ = "A" Then
For i = 1 To IH.ArmHas
If UCase(itm) = UCase(IH.Armour(i)) Then
FindItem = i
Exit Function
End If
Next i
End If

If typ = "I" Then
For i = 1 To IH.ItmHas
If UCase(itm) = UCase(IH.Items(i)) Then
FindItem = i
Exit Function
End If
Next i
End If
FindItem = 0
End Function
