Attribute VB_Name = "Module1"
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long


Public Type World
  WorldName(1 To 200) As String
  WorldChar(1 To 200) As String
  WorldCond(1 To 200) As String
  BKDefLoc(1 To 200) As String
  MidDefLoc(1 To 200) As String
  WorldType(1 To 200) As String
  IntroReturn(1 To 200) As String
  WorldBkGr(1 To 200) As String
  WorldMidi(1 To 200) As String
  WorldSprite1(1 To 200) As String
  WorldSprite2(1 To 200) As String
  WorldSprite3(1 To 200) As String
  WorldSprite4(1 To 200) As String
  WorldHotSpots(1 To 200) As String
  WorldHotButton(1 To 200) As Boolean
  WorldHotScroll(1 To 200) As String
  WorldHotType(1 To 200) As String
  WorldHotItem(1 To 200) As String
  WorldChange(1 To 200) As String
  WorldText(1 To 200) As String
  FrameWalk(1 To 200) As Integer
  m_X(1 To 200) As String
  m_Y(1 To 200) As String
  m_SX(1 To 200) As String
  m_SY(1 To 200) As String
  m_FX(1 To 200) As String
  m_FY(1 To 200) As String
End Type

Public Type SpriteSettings
  HeroSettX(1 To 200) As String
  HeroSettY(1 To 200) As String
  HeroStrX(1 To 200) As String
  HeroStrY(1 To 200) As String
  HeroMoveX(1 To 200) As String
  HeroMoveY(1 To 200) As String
End Type

Public Type Walking
 TotalFrames As Integer
 DefLoc As String
 BMPname As String
 Soundz As String
 AddZero As Boolean
End Type

Public Type Standing
 TotalFrames As Integer
 DefLoc As String
 BMPname As String
 Soundz As String
 AddZero As Boolean
End Type

Public Type CharacterStrength
 HP As String
 MP As String
End Type

Public Type NormalAttacks
 AttackName(1 To 99) As String
 TotalFrames(1 To 99) As Integer
 BMPname(1 To 99) As String
 PreBMP(1 To 99) As String
 EndBMP(1 To 99) As String
 PreTotFrame(1 To 99) As String
 EndTotFrame(1 To 99) As String
 DefLoc(1 To 99) As String
 Soundz(1 To 99) As String
 Sound2(1 To 99) As String
 Sound3(1 To 99) As String
 mType(1 To 99) As String
 aX(1 To 99) As String
 aY(1 To 99) As String
 aSX(1 To 99) As String
 aSY(1 To 99) As String
 SFrame1(1 To 99) As Variant
 SFrame2(1 To 99) As Variant
 SFrame3(1 To 99) As Variant
 AddZero(1 To 99) As Boolean
 AttackDamage(1 To 99) As Integer
End Type

Public Type e_NormalAttacks
 AttackName(1 To 99) As String
 TotalFrames(1 To 99) As Integer
 BMPname(1 To 99) As String
 PreBMP(1 To 99) As String
 EndBMP(1 To 99) As String
 PreTotFrame(1 To 99) As String
 EndTotFrame(1 To 99) As String
 DefLoc(1 To 99) As String
 Soundz(1 To 99) As String
 Sound2(1 To 99) As String
 Sound3(1 To 99) As String
 mType(1 To 99) As String
 aX(1 To 99) As String
 aY(1 To 99) As String
 aSX(1 To 99) As String
 aSY(1 To 99) As String
 SFrame1(1 To 99) As Variant
 SFrame2(1 To 99) As Variant
 SFrame3(1 To 99) As Variant
 AddZero(1 To 99) As Boolean
 AttackDamage(1 To 99) As Integer
End Type

Public Type e_Settings
 e_FilNme(1 To 200) As String
 e_BmpNme(1 To 200) As String
 e_DefLoc(1 To 200) As String
 e_Frames(1 To 200) As String
 e_AddZero(1 To 200) As String
 e_X(1 To 200) As String
 e_Y(1 To 200) As String
 e_SX(1 To 200) As String
 e_SY(1 To 200) As String
End Type

Public DoRScrl As Boolean
Public CharDF As String
Public GlobLoaded As String
Public selNum As Variant
Public selType As Variant
Public MagI As Variant
Public Snd1(1 To 4) As Integer
Public snd2(1 To 4) As Integer
Public Snd3(1 To 4) As Integer
Public AcSnd(1 To 3)
Public ModeIs As String
Public FrameWalk As Integer
Public TmpSprNme(1 To 4) As String
Public TmpSprF(1 To 4)
Public TmpSprX(1 To 4)
Public TmpSprY(1 To 4)
Public TmpSprSX(1 To 4)
Public TmpSprSY(1 To 4)
Public GlobalR As Integer
Public HerosName As String
Public Wld As World
Public SpriteSett As SpriteSettings
Public NormDone As Integer
Public Walk1 As Walking
Public Stand1 As Standing
Public CharStr As CharacterStrength
Public CharType As String
Public EnStyle As String
Public EnSmarts As String
Public NormAttack As NormalAttacks
Public e_NormAttack As e_NormalAttacks
Public e_Sett As e_Settings
Public DoAttack As Boolean

Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_MEMORY = &H4
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10


Function GetIni(Path, Proces, AppNme)
Dim Process As String
Process = Proces
buffer$ = String$(250, " ")
num& = 250
result = GetPrivateProfileString(AppNme, Process, vbNullString, buffer$, num&, Path)
buffer$ = Mid$(buffer$, 1, result)
GetIni = buffer$
End Function

Function WriteIni(Path, Process As String, Key, AppNme)
Dim Keyy As String
Keyy = Key
result = WritePrivateProfileString(AppNme, Process, Keyy, Path)
WriteIni = result
End Function

Sub PlayMidi(Snd, flag)
r = Right(Snd, 3)
If UCase(r) = "MID" Then
 If flag = "open" Then
  X& = mciSendString("open " & Snd & " Type sequencer Alias MFile", 0&, 0, 0)
  X& = mciSendString("play MFile", 0&, 0, 0)
 Else
  X& = mciSendString("stop MFile", 0&, 0, 0)
  X& = mciSendString("close MFile", 0&, 0, 0)
 End If
Else
 r = PlaySound(Snd, 0, 0&)
End If
End Sub

Function RC4(SS, S)
On Error Resume Next
Text2 = SS
Text1 = S
For i = 0 To 255
    DDD = DDD & Chr(i Mod 256 + 1)
Next
SBox = DDD
DDD = ""
For i = 0 To 255
    k = Asc(Mid(Text2, i Mod Len(Key), 1))
    j = (j + Asc(Mid(SBox, i, 1)) + k) Mod 256
    DDD = DDD & Chr(j Mod 256 + 1)
Next
SBox = DDD
DDD = ""
On Error Resume Next
texti = Text1
For i = 1 To Len(Text1)
    C = Asc(Mid(texti, i, 1)) - 1
    j = (j + Asc(Mid(SBox, i, 1))) Mod 256
    t = (Asc(Mid(SBox, i, 1)) + Asc(Mid(SBox, j, 1))) Mod 256
    k = Asc(Mid(SBox, t, 1)) Mod 256
    C = C Xor k
    Mid(texti, i, 1) = Chr(C Mod 256 + 1)
Next
RC4 = texti
End Function
